<script lang="ts">
import Vue from 'vue';
import { CarouselWrap } from '../../common/index.vue';
import CaseStudyQuote from './partners-case-study-quote.vue';
import { numberToDigitString } from '~/common/util';

export default Vue.extend({
  name: 'PartnersQuotesCarousel',
  components: { CarouselWrap, CaseStudyQuote },
  props: {
    data: {
      type: Object,
      required: true,
    },
    offset: {
      type: Number,
      required: false,
      default: 0,
    },
  },
  data() {
    return {
      step: 0,
    };
  },
  computed: {
    formattedStep() {
      return `${numberToDigitString(this.step + 1)} - ${numberToDigitString(
        this.data.quotes.length,
      )}`;
    },
    singleQuote(): boolean {
      return this.data.quotes.length === 1;
    },
  },
  methods: {
    goNext() {
      this.$refs.carousel.next();
      this.step = this.step >= this.data.quotes.length - 1 ? 0 : this.step + 1;
    },
    goPrev() {
      this.$refs.carousel.prev();
      this.step = this.step <= 0 ? this.data.quotes.length - 1 : this.step - 1;
    },
  },
});
</script>

<template>
  <section
    class="quotes-carousel"
    :class="{
      'no-background': data.no_background,
      'no-padding': singleQuote || data.no_padding,
      'no-margin': data.no_margin,
    }"
  >
    <SlpContainer :class="{ offset }">
      <SlpRow>
        <div v-if="data.decoration" class="decoration"></div>
        <div class="quotes-carousel__header">
          <SlpTypography v-if="data.header" tag="h2" variant="heading2-bold"
            ><span v-html="data.header"></span>
          </SlpTypography>
        </div>
        <CarouselWrap ref="carousel" :items="data.quotes">
          <template #content>
            <template v-if="$refs.carousel">
              <CaseStudyQuote
                v-for="quoteNumber in $refs.carousel.itemIndexes"
                :key="`quote-${quoteNumber}`"
                class="quotes-carousel__quote"
                :data="data.quotes[quoteNumber]"
                :data-ga-carousel="data.quotes[quoteNumber].ga_carousel"
                :full-width="data.full_width"
              />
            </template>
          </template>
        </CarouselWrap>
        <div
          v-if="singleQuote"
          class="quotes-carousel__footer-decoration"
        ></div>
        <div
          v-if="!singleQuote"
          class="quotes-carousel__footer quotes-carousel__footer-decoration"
        >
          <SlpTypography tag="span" variant="body1" class="quote-count">{{
            formattedStep
          }}</SlpTypography>
          <div>
            <SlpButton
              variant="icon"
              aria-label="Prev"
              @click.native="goPrev()"
            >
              <SlpIcon
                name="chevron-lg-left"
                variant="product"
                hex-color="#171321"
              />
            </SlpButton>
            <SlpButton
              variant="icon"
              aria-label="Next"
              @click.native="goNext()"
            >
              <SlpIcon
                class="slp-ml-8"
                name="chevron-lg-right"
                variant="product"
                hex-color="#171321"
              />
            </SlpButton>
          </div>
        </div>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.quotes-carousel {
  padding: $spacing-96 0;
  background-color: $color-surface-800;
  margin: $spacing-160 0;

  &.no-background {
    background-color: transparent;
  }
  &.no-padding {
    padding: 0;
  }
  &.no-margin {
    margin: 0;
  }
  @media (min-width: $breakpoint-md) {
    padding-left: 5%;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
    margin: $spacing-32 0;
  }

  &__header {
    display: flex;
    width: 100%;
    flex-direction: column;
    padding-bottom: $spacing-32;
    border-bottom: 1px solid $color-surface-300;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
      align-items: center;
    }

    &:deep a {
      @media (max-width: $breakpoint-md) {
        padding-left: 0;
      }
    }
  }

  &__quote {
    display: inline-flex;
    margin-right: $spacing-16;
    flex: 0 0 100%;
  }

  &__footer {
    display: flex;
    align-items: center;
    padding: $spacing-16 0;
    .quote-count {
      margin-right: auto;
    }
  }

  &__footer-decoration {
    width: 100%;
    border-top: 1px solid $color-surface-300;
  }
}

.decoration {
  height: 4px;
  margin-top: $spacing-96;
  width: 96px;
  border-radius: 20px;
  margin-bottom: $spacing-24;
  background: rgb(255, 203, 215);
  background: linear-gradient(
    90deg,
    rgba(255, 203, 215, 1) 0%,
    rgba(241, 205, 234, 1) 51%,
    rgba(211, 191, 238, 1) 100%
  );
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-64;
  }
}

.offset {
  @media (max-width: 1900px) {
    padding-left: 10%;
  }
  @media (max-width: $breakpoint-2xl) {
    padding-left: 15%;
  }
  @media (max-width: $breakpoint-xl) {
    padding-left: 15%;
  }
  @media (max-width: $breakpoint-lg) {
    padding-left: 20%;
  }
  @media (max-width: 1024px) {
    padding-left: 0;
  }
}
</style>
